package CMS;

use strict;

use MT::PagePublishController;

sub check {
    my ($cb, %args) = @_;
    return 1 if $args{ArchiveType} ne 'Page';

    my $id = $args{Entry}->id;
    my $ppc = MT::PagePublishController->load({ entry_id => $id });
    return 0 if $ppc->no_publish;
    return 1;
}

sub save_publish_flag {
    my ($cb, $app, $obj, $org) = @_;
    my $id = $obj->id;
    if ($id) {
        my $ppc = MT::PagePublishController->load({ entry_id => $id });
        my $q = $app->param;
        my $no_publish = $q->param('no_publish');
        unless (defined $ppc) {
            $ppc = MT::PagePublishController->new;
            $ppc->entry_id($id);
        }
        $ppc->no_publish($no_publish);
        $ppc->save or die $ppc->errstr;
    }
    return 1;
}

sub delete_publish_flag {
    my ($cb, $app, $obj) = @_;
    my $id = $obj->id;
    if ($id) {
        my $ppc = MT::PagePublishController->load({ entry_id => $id });
        return 1 unless defined $ppc;
        $ppc->remove;
    }
    return 1;
}

sub get_publish_flag {
    my ($cb, $app, $param, $tmpl) = @_;

    return if $param->{object_type} ne 'page';

    my $nopublish = MT->translate('No Publish');
    my $field = $tmpl->getElementById('category');

    my $node = $tmpl->createElement('app:setting',
        { id => 'no_publish', label => 'NoPublish', label_class => "no-header" });
    my $innerHTML = '<ul><li><input type="checkbox" name="no_publish" id="no_publish" value="1"<mt:if name="no_publish"> checked="checked"</mt:if> class="cb" /> <label for="no_publish">'.$nopublish.'</label></li></ul>';
    $node->innerHTML($innerHTML);
    $tmpl->insertAfter($node, $field);

    my $id = $param->{id};
    if ($id) {
        my $ppc = MT::PagePublishController->load({ entry_id => $id });
        unless (defined $ppc) {
            $param->{no_publish} = 0;
        } else {
            $param->{no_publish} = $ppc->no_publish;
        }
    }
}

1;
